/*******************************************************************************
 
  $Id: console_io.h,v 1.1 1999-08-22 11:03:32+04 eug Exp eug $

  (C) Copyright 1998-99 by Eugene Surovegin <ebs@innocent.com>

  Console I/O

*******************************************************************************/
#ifndef __CONSOLE_IO_H_
#define __CONSOLE_IO_H_

/* 
#define FOREGROUND_BLUE      0x01 // text color contains blue.
#define FOREGROUND_GREEN     0x02 // text color contains green.
#define FOREGROUND_RED       0x04 // text color contains red.
#define FOREGROUND_INTENSITY 0x08 // text color is intensified.
#define BACKGROUND_BLUE      0x10 // background color contains blue.
#define BACKGROUND_GREEN     0x20 // background color contains green.
#define BACKGROUND_RED       0x40 // background color contains red.
#define BACKGROUND_INTENSITY 0x80 // background color is intensified.
*/

/*
    Color control ESC-chars format

    {\027} {attribute}
    e.g.   "\027\x0f" 
*/

#define TEXT_ATTR(f,b) ((b<<4) | f)

// Some esc sequences (black background)
#define BLUE_B          "\027\x01"
#define GREEN_B         "\027\x02"
#define CYAN_B          "\027\x03"
#define RED_B           "\027\x04"
#define MAGENTA_B       "\027\x5"
#define BROWN_B         "\027\x6"
#define LIGHTGRAY_B     "\027\x7"
#define DARKGRAY_B      "\027\x8"  
#define LIGHTBLUE_B     "\027\x9"
#define LIGHTGREEN_B    "\027\xa"
#define LIGHTCYAN_B     "\027\xb"
#define LIGHTRED_B      "\027\xc"
#define LIGHTMAGENTA_B  "\027\xd"
#define YELLOW_B        "\027\xe"
#define WHITE_B         "\027\xf"

class TConsoleIO {

  public:
    enum COLORS {     
      BLACK = 0,      // \x0
      BLUE,           // \x1
      GREEN,          // \x2
      CYAN,           // \x3
      RED,            // \x4
      MAGENTA,        // \x5
      BROWN,          // \x6
      LIGHTGRAY,      // \x7
      DARKGRAY,       // \x8  
      LIGHTBLUE,      // \x9
      LIGHTGREEN,     // \xa
      LIGHTCYAN,      // \xb
      LIGHTRED,       // \xc
      LIGHTMAGENTA,   // \xd
      YELLOW,         // \xe
      WHITE           // \xf
    };

  public:

    TConsoleIO();
    TConsoleIO(const char*);

    ~TConsoleIO();

    void SetTextAttribute(BYTE);
    void SetTitle(const char*);
    
    void WriteString(const char*);
    void WriteFormattedString(const char*);

    void PrintfString(const char*, ...);
    void PrintfFormattedString(const char*, ...);
    
    void RestoreTextAttr();

  private:
    void   Init();
    
    HANDLE std_out;
    HANDLE std_in;
    HANDLE std_err;

    BYTE   save_attr;
};


#endif